Subject: [PATCH] mmc: dw_mmc: try pick the exact same voltage as vmmc for vqmmc

From: [email-masked] (addy ke)
Date: Thu, 13 Nov 2014 10:19:26 +0800

On 2014/11/13 02:04, Doug Anderson wrote:
> Ulf,
> 
> On Tue, Nov 11, 2014 at 12:52 AM, Ulf Hansson <[email-masked]> wrote:
>> On 11 November 2014 05:02, Addy Ke <[email-masked]> wrote:
>>> SD2.0 cards need vqmmc and vmmc to be the same.
>>
>> No, that's not correct.
>>
>> If I remember the spec correctly, the bus signal threshold is 0.75 * VDD.
> 
> As usual, I will first state my utter lack of knowledge of all things mmc.
> 
> Now that's out of the way, on two separate board with two separate
> SoCs I've heard stories of cards that don't work when there's a big
> gap between vmmc and vqmmc.
> 
> If my memory serves, previously I heard of problems with vmmc=3.3V and
> vqmmc=2.8V.  That means there were problems with .85 * VDD.  Certainly
> Addy seems to have a card that has problems with vmmc=3.3V and
> vqmmc=2.7V (but worked with vmmc=3.3V and vqmmc=2.8V).  That is .82 *
> VDD.
> 
> I have no idea if these old cards are "to spec", but they exist and it
> would be nice to support them.
> 
> It seems like the absolute safest thing would be to try to keep vmmc
> and vqmmc matching if possible, especially during card probe.  Once
> voltage negotiation happened then the vqmmc could go down.
> 
> 
>>> But vqmmc call regulator_set_voltage to set min_uv(2.7v) as far as possible.
>>
>> I guess you want to do that to save as much power as possible.
> 
> I don't think it's Addy wanting it, I think it's the regulator framework.
> 
> If a regulator is current 1.8V and you request 2.7 - 3.3V, the
> framework needs to pick one of those voltages.  I believe it will pick
> 2.7V.
> 
> ...so I think we get into trouble only when the 2.0 card is plugged in
> after a UHS card has negotiated down the voltage, but I could be
> wrong.  Maybe Addy can clarify.
> 
Sure
If the first card is sd2.0 since startup, dw_mci_switch_voltage will not be called,
and card can be identified. But if UHS card is pulgged in first, the vqmmc will be down to 1.8v.

when sd2.0 card is pulgged in, mmc core will call dw_mci_switch_voltage to change vqmmc to 3.3v
(MMC_SINGLE_VOTAGE_330). So vqmmc will be set 2.7v, if we request 2.7-3.6v.

But vmmc is always 3.3v,becuase it be set min_volt = max_volt = 3.3v in dt tables.

So the result:
vmmc = 3.3v and vqmmc = 2.7v, and sd2.0 card is failed to identify in my test.

> 
>>> @@ -1163,8 +1163,14 @@ static int dw_mci_switch_voltage(struct mmc_host *mmc, struct mmc_ios *ios)
>>>          */
>>>         uhs = mci_readl(host, UHS_REG);
>>>         if (ios->signal_voltage == MMC_SIGNAL_VOLTAGE_330) {
>>> -               min_uv = 2700000;
>>> -               max_uv = 3600000;
>>> +               /* try pick the exact same voltage as vmmc for vqmmc */
>>
>> This seems like a generic SD protocol issue.
>>
>> Should we maybe provide some helper function from the mmc core, which
>> in principle take the negotiated card->ocr into account while
>> calculating the signal voltage level. Typically min_uv should be 0.75
>> x (card->ocr), for these cases.
> 
> Yes, if there are ways to make the solution more generic I would
> certainly support that.
> 
> -Doug
> 
> 
>